//Librerias RED
#include <SPI.h>  //Importamos librería comunicación SPI
#include <Ethernet.h>  //Importamos librería Ethernet
 
byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };//Ponemos la dirección MAC de la Ethernet Shield que está con una etiqueta debajo la placa
IPAddress ip(192,168,1,101); //Asingamos la IP al Arduino
EthernetServer server(14101); //Creamos un servidor Web con el puerto 80 que es el puerto HTTP por defecto
IPAddress serve2(213,73,35,63); // Direccion ip del servidor UOC (eimtcms.uoc.edu)
//IPAddress serve2(192,168,1,38);


//--------------Dispositiu--------------------

#define dispositiu "102"
#define nom_dispositiu_uocdomo "Dormitori-nen"
#define mail_avis "betulo92@gmail.com"
#define mail_dispositiu "betulo92@gmail.com"

//---------------------------------------------


//Librerias Sensor Temperatura
#include "DHT.h" 
#define DHTPIN 2 
#define DHTTYPE DHT11 
DHT dht(DHTPIN, DHTTYPE);

//Librerias LDR
int lightPin = 1; // Pin A0 LDR.
int valor; // Variable para cálculos.


//Librerias GAS
#define         MQ1                       (0)     //define la entrada analogica para el sensor
#define         RL_VALOR             (5)     //define el valor de la resistencia mde carga en kilo ohms
#define         RAL       (9.83)  // resistencia del sensor en el aire limpio / RO, que se deriva de la                                             tabla de la hoja de datos
#define         GAS_LP                      (0)
String inputstring = "";                                                        //Cadena recibida desde el PC
float           LPCurve[3]  =  {2.3,0.21,-0.47};
float           Ro           =  10;

//Librerias Movimiento
const int PIRPin= 3;


int pirState = LOW;           // de inicio no hay movimiento
int vales = 0;                  // estado del pin


//-------------------------------------------------


//variables alertes
int alerta_temp=0;
int alerta_pres=0;
int alerta_gas=0;
int tempss=0;
int presvalor=0;
String missatge = "Alerta UOC_domo Menjador" ;
int dis_t=0;
int dis_g=0;
int dis_p=0;
int flagd=0;

//----------------
void setup(){
Serial.begin(9600); // Inicializa el puerto serie.

 // Inicializamos la comunicación Ethernet y el servidor
  Ethernet.begin(mac, ip);
  server.begin();
  Serial.print("IP_LOCAL Uoc-Domo: ");
  Serial.println(Ethernet.localIP());

//DHT11
dht.begin(); //Se inicia el sensor de Temperatura

//GAS
Serial.println("Iniciando Sensor GAS...");
   //configuracion del sensor
  Serial.print("Calibrando...\n");
  Ro = Calibracion(MQ1);                        //Calibrando el sensor.
  Serial.print("Calibracion finalizada...\n");
  Serial.print("Ro=");
  Serial.print(Ro);
  Serial.print("kohm");
  Serial.print("\n");

//Movimiento
 pinMode(PIRPin, INPUT);
 
  
}


void loop(){

//Sensor LDR
valor = analogRead(lightPin); // Leemos el valor de A0.
Serial.print ("Luz: ");
Serial.println(valor); // Valor de entrada de A0.
//Fin LDR

//Sensor DHT11 Temperatura
float h = dht.readHumidity()+30; //se lee la humedad
  float t= dht.readTemperature(); // se lee la temperatura
  Serial.print("Humedad: "); 
  Serial.println(h); 
  Serial.print("Temperatura :"); 
  Serial.println(t); 
  //Fin DHT11


//GAS
Serial.print("LP:");
   Serial.print(porcentaje_gas(lecturaMQ(MQ1)/Ro,GAS_LP) );
   Serial.print( "ppm" );
   Serial.print("    ");
   Serial.print("\n");
//Fin GAS

//Movimiento   
vales = digitalRead(PIRPin);
  if (vales == HIGH)   //si está activado
  { 
   Serial.println("Sensor ON");
   presvalor=1;
    if (pirState == LOW)  //si previamente estaba apagado
    {
      //Serial.println("Sensor activado");
      pirState = HIGH;
    }
  } 
  else   //si esta desactivado
  {
   Serial.println("Sensor OFF");
   presvalor=0;
    if (pirState == HIGH)  //si previamente estaba encendido
    {
      //Serial.println("Sensor parado");
      pirState = LOW;
    }
  }
//Fin movimiento

//Alertes
Serial.print("alerta de temp=");
Serial.println(alerta_temp);

Serial.print("-alerta de gas=");
Serial.println(alerta_gas);

Serial.print("-alerta de presencia=");
Serial.println(alerta_pres);
Serial.print("\n");
Serial.print("-disparador t=");
Serial.println(dis_t);
Serial.print("-disparador g=");
Serial.println(dis_g);
Serial.print("-disparador p=");
Serial.println(dis_p);
Serial.println(tempss);
Serial.println("------======------");

tempss=tempss+1;
if(tempss==1501){Serial.println("//-------------------Envia dades a la web------------------------------------\\");
tempss=0;}

//


  EthernetClient client = server.available(); //Creamos un cliente Web
  //Cuando detecte un cliente a través de una petición HTTP
  if (client) {
    Serial.println("new client");
    boolean currentLineIsBlank = true; //Una petición HTTP acaba con una línea en blanco
    String cadena=""; //Creamos una cadena de caracteres vacía
    while (client.connected()) {
      if (client.available()) {
        char c = client.read();//Leemos la petición HTTP carácter por carácter
        Serial.write(c);//Visualizamos la petición HTTP por el Monitor Serial
        cadena.concat(c);//Unimos el String 'cadena' con la petición HTTP (c). De esta manera convertimos la petición HTTP a un String
 
         //Ya que hemos convertido la petición HTTP a una cadena de caracteres, ahora podremos buscar partes del texto.
         int posicion=cadena.indexOf("altemp="); //Guardamos la posición de la instancia "altemp=" a la variable 'posicion'
           if(cadena.substring(posicion)=="altemp=1"){alerta_temp=1;}
           if(cadena.substring(posicion)=="altemp=0"){alerta_temp=0;}
         
         int posicion2=cadena.indexOf("algas="); //Guardamos la posición de la instancia "algas=" a la variable 'posicion2'
          if(cadena.substring(posicion2)=="algas=1"){alerta_gas=1;}
          if(cadena.substring(posicion2)=="algas=0"){alerta_gas=0;}

         int posicion3=cadena.indexOf("alpres="); //Guardamos la posición de la instancia "alpres=" a la variable 'posicion2'
          if(cadena.substring(posicion3)=="alpres=1"){alerta_pres=1;}
          if(cadena.substring(posicion3)=="alpres=0"){alerta_pres=0;}


        //Cuando reciba una línea en blanco, quiere decir que la petición HTTP ha acabado y el servidor Web está listo para enviar una respuesta
        if (c == '\n' && currentLineIsBlank) {
 
            // Enviamos al cliente una respuesta HTTP
            client.println("HTTP/1.1 200 OK");
            client.println("Content-Type: text/html");
            client.println();
 
            //Página web en formato HTML
            client.println("<html>");
            client.println("<head>");
            //client.println("<META HTTP-EQUIV='REFRESH' CONTENT='5;URL=http://192.168.1.101'>");
            client.println("</head>");
            client.println("<body>");
            client.println("<h1 align='center'>UOC-Domo</h1><h3 align='center'>Dispositiu=");
            client.print(nom_dispositiu_uocdomo);
            client.print("</h3>");
            client.println("<div style='text-align:center;'>");
            client.println("<br /><br />");
            client.println("<b>LDR = ");
            client.print(valor);
            client.println(";TEMP=");
            client.print(t);
            client.println(";HUMI=");
            client.print(h);
            client.println(";mail=");
            client.print(mail_avis);
            client.println("<br /><br />");
            client.println("Alerta Temperatura=");
            client.println(alerta_temp);
            client.println(";  Alerta Gas=");
            client.println(alerta_gas);
            client.println("; Alerta Presencia=");
            client.println(alerta_pres);
            client.println("</b><br />");
            client.println("</b></body>");
            client.println("</html>");
            break;
        }
        if (c == '\n') {
          currentLineIsBlank = true;
        }
        else if (c != '\r') {
          currentLineIsBlank = false;
        }
      }
    }




    
    //Dar tiempo al navegador para recibir los datos
    delay(1);
    client.stop();// Cierra la conexión
  }

//--disparadores alertas

if((t>25)){int dis_t=1;
flagd=1;
Serial.println("disparador T=1");}else{
  dis_t=0;
}

if((t<10)){int dis_t=1;
Serial.println("---disparador T=");
Serial.println(dis_t);}else{
  dis_t=0;
}

if((porcentaje_gas(lecturaMQ(MQ1)/Ro,GAS_LP))>5){int dis_g=1;
Serial.print("---disparador G=");
Serial.println(dis_g);}else{
  dis_g=0;
}

if(presvalor>0){int dis_p=1;
Serial.print("---disparador P=");
Serial.println(dis_p);}else{
  dis_p=0;
}
//---

if((dis_t==1)&&(alerta_temp==1)){int flagd=1;}else{int flagd=0;}
if((dis_g==1)&&(alerta_gas==1)){int flagd=1;}else{int flagd=0;}
if((dis_p==1)&&(alerta_pres==1)){int flagd=1;}else{int flagd=0;}
Serial.print("flagd=");
Serial.println(flagd);
if(flagd==1) {Serial.print("---//---ALERTA---\\---");
 }
//---
if((tempss==50)&&(flagd==1)) { //si cualquiera de las 3 alertas es positiva
  Serial.print("---//---flagd1-- enviar un mail alerta---\\---");
        if (client.connect(serve2, 80)>0) {  // Se conecta al servidor
             client.print("GET /~ohidalgo/mail_alerta.php?e="); //envia petición web al servidor
              Serial.print("GET /~ohidalgo/mail_alerta.php?e=");
            client.print(mail_avis);
              Serial.print(mail_avis);
            client.print("&t=");
              Serial.print("&t=");
            client.print("UOC-Domo_ALERTA");
              Serial.print("UOC-Domo_ALERTA");
            client.print("&m=");
              Serial.print("&m=");
            client.print(missatge);
              Serial.print(missatge);
            client.println();
              Serial.println();
            client.println(" HTTP/1.0");
              Serial.println(" HTTP/1.0");
            client.println("User-Agent: Arduino 1.0");
              Serial.println("User-Agent: Arduino 1.0");
            client.println();
              Serial.println();
              Serial.print("-fin-");
           } else {
              Serial.println("Fallo en la conexion");
                  }
          if (!client.connected()) {
              Serial.println("Disconnected!");
          }
          client.stop();
          client.flush();

}


//--


       if(tempss==20){ //equivale a 15 minutos
                if (client.connect(serve2, 80)>0) {  // Se conecta al servidor
            client.print("GET /~ohidalgo/inserta.php?id="); //UOC
            String localwww;
            localwww = String ("GET /~ohidalgo/inserta.php?id=");
         //    localwww = localwww;
             Serial.print(localwww );
            client.print(dispositiu);
             Serial.print(dispositiu);
            client.print("&t=");
             Serial.print("&t=");
            client.print(t);
             Serial.print(t);
            client.print("&h=");
              Serial.print("&h=");
            client.print(h);
              Serial.print(h);
            client.print("&g=");
              Serial.print("&g=");
            client.print(porcentaje_gas(lecturaMQ(MQ1)/Ro,GAS_LP));
              Serial.print(porcentaje_gas(lecturaMQ(MQ1)/Ro,GAS_LP));
              client.print("&l=");
              Serial.print("&l=");
            client.print(valor);
              Serial.print(valor);
              client.print("&p=");
              Serial.print("&p=");
            client.print(presvalor);
              Serial.print(presvalor);
           // client.println();
              Serial.println();
            client.println(" HTTP/1.0");
              Serial.println(" HTTP/1.0");
            client.println("User-Agent: Arduino 1.0");
              Serial.println("User-Agent: Arduino 1.0");
            client.println();
              Serial.println();
              Serial.println("-fin-");
           } else {
              Serial.println("Fallo en la conexion");
                  }
          if (!client.connected()) {
              Serial.println("Disconnected!");
          }
          client.stop();
          client.flush();
          //delay(19000);
      }

}


//---------------------------------------------------
//GAS
float calc_res(int raw_adc)
{
  return ( ((float)RL_VALOR*(1023-raw_adc)/raw_adc));
}
 
float Calibracion(float mq_pin){
  int i;
  float val=0;
    for (i=0;i<50;i++) {                                                                               //tomar múltiples muestras
    val += calc_res(analogRead(mq_pin));
    delay(500);
  }
  val = val/50;                                                                                         //calcular el valor medio
  val = val/RAL;
  return val;
}
 
float lecturaMQ(int mq_pin){
  int i;
  float rs=0;
  for (i=0;i<5;i++) {
    rs += calc_res(analogRead(mq_pin));
    delay(50);
  }
rs = rs/5;
return rs;
}
 
int porcentaje_gas(float rs_ro_ratio, int gas_id){
   if ( gas_id == GAS_LP ) {
     return porcentaje_gas(rs_ro_ratio,LPCurve);
   }
  return 0;
}
 
int porcentaje_gas(float rs_ro_ratio, float *pcurve){
  return (pow(10, (((log(rs_ro_ratio)-pcurve[1])/pcurve[2]) + pcurve[0])));
}
